diff -ruN qmail-1.03-orig/output.c qmail-1.03-ldap-20060201-orig/output.c
--- qmail-1.03-orig/output.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/output.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,181 @@
+/*
+ * Copyright (c) 2001-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#include "stralloc.h"
+#include "substdio.h"
+#include "fmt.h"
+#include "str.h"
+#include "scan.h"
+#include "output.h"
+
+#include <stdarg.h>
+
+char num[FMT_ULONG];
+
+static const char nullString[] = "(null pointer)";
+static const char ioHexArray[] = "0123456789abcdef";
+
+static int fmt_hexulong(char *s, unsigned long x) 
+	/* s has to be allready allocated, use at least FMT_ULONG chars 
+	 * 40 chars should be enough for a 20 byte unsigned long (2^160) 
+	 * so djb's fmt_ulong would first fail ;-) */
+{
+	unsigned int i;
+
+	for (i = 0; i < sizeof(unsigned long) * 2; i++) {
+		*s++ = (ioHexArray[(x >> (sizeof(unsigned long)*8 - 4)) & 0xf]);
+		x = x << 4;
+	}
+	return sizeof(unsigned long) * 2;
+}
+
+void va_output(substdio *ss, char const *fmt, va_list args)
+/*
+ * works like vprintf has the format options %i, ...
+ * all flags (#, 0, -, ' ', +, ' ... ) are not supported if not special noted
+ * Also not supported are all options for foating-point numbers 
+ * (not needed in qmail)
+ * Supported conversion specifiers: diouxcsSp%
+ * diux are for integer (long) conversions
+ * c is a single unsigned char
+ * s is a zero terminated string
+ * S is a stralloc object (should not be zero terminated (else the zero 
+ *   will be printed))
+ * p is the hex address of a generic pointer (void *)
+ * % is the % sign
+ */
+{
+	unsigned long ul;
+	long l;
+	char *s;
+	char const *start;
+	char const *cur;
+	void *p;
+	unsigned char c;
+	stralloc *sa;
+
+	start = fmt;
+	cur = fmt;
+	if (!cur) return;
+	while (*cur) {
+		if (*cur == '%') {
+			if ( substdio_put(ss, start, cur-start) == -1 ) return;
+			/*
+			 * no need to care if the output is save qmail-send
+			 * looks if the output is save
+			 */
+			cur++;
+			switch (*cur) {
+			case 'd':
+			case 'i':
+				l = va_arg(args, long);
+				if (l < 0) {
+					/* negativ number, d and i are signed */
+					l *= -1;
+					if (substdio_put(ss, "-", 1) == -1)
+						return;
+				}
+				ul = (unsigned long)l;
+				if (substdio_put(ss, num, fmt_ulong(num, ul))) 
+					return;
+				break;
+			case 'u':
+				ul = va_arg(args, unsigned long);
+				if (substdio_put(ss, num, fmt_ulong(num, ul))) 
+					return;
+				break;
+			case 's':
+				s = va_arg(args, char *);
+				if (!s) {
+					if (substdio_put(ss, nullString, 
+						    str_len(nullString))) 
+						return;
+					break;
+				}
+				if (substdio_put(ss, s, str_len(s))) return;
+				break;
+			case 'S':
+				sa = va_arg(args, stralloc *);
+				if (!sa) {
+					if (substdio_put(ss, nullString, 
+						    str_len(nullString)))
+						return;
+					break;
+				}
+				if (substdio_put(ss, sa->s, sa->len))
+					return;
+				break;
+			case '%':
+				if (substdio_put(ss, "%", 1) == -1)
+					return;
+				break;
+			case 'p':
+				p = va_arg(args, void *);
+				ul = (unsigned long)p;
+				if (substdio_put(ss, "0x", 2)) return;
+				if (substdio_put(ss, num,
+					    fmt_hexulong(num, ul))) 
+					return;
+				break;
+			case 'x':
+				ul = va_arg(args, unsigned long);
+				if (substdio_put(ss, "0x", 2)) return;
+				if (substdio_put(ss, num,
+					    fmt_hexulong(num, ul))) 
+					return;
+				break;
+			case 'c':
+				c = (unsigned char)
+				    va_arg(args, unsigned int);
+				substdio_BPUTC(ss, c);
+				break;
+			}
+			start = ++cur; 
+		} else {
+			++cur;
+		}
+	}
+	if (substdio_put(ss, start, cur-start) == -1) return;
+}
+
+void output(substdio *ss, char const *fmt, ...)
+	/* see va_output */
+{
+	va_list args;
+
+	va_start(args,fmt);
+	va_output(ss, fmt, args);
+	va_end(args);
+	if (substdio_flush(ss) == -1) return; 
+}
+
diff -ruN qmail-1.03-orig/output.h qmail-1.03-ldap-20060201-orig/output.h
--- qmail-1.03-orig/output.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/output.h	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,62 @@
+/*
+ * Copyright (c) 2001-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#ifndef __OUTPUT_H__
+#define __OUTPUT_H__
+
+#include <stdarg.h>
+#include "substdio.h"
+
+#define STDERR 2
+#define STDOUT 1
+#define STDIN  0
+
+void va_output(substdio *ss, char const *fmt, va_list args);
+/*
+ * works like printf has the format options %i, ...
+ * all flags (#, 0, -, ' ', +, ' ... ) are not supported
+ * Also not supported are all options for foating-point numbers 
+ * (not needed in qmail)
+ * Supported conversion specifiers: diuxcsSp%
+ * diux are for integer (long) conversions (di are signed all other unsigned)
+ * c is a single unsigned char
+ * s is a zero terminated string
+ * S is a stralloc object (should not be zero terminated (else the zero 
+ *   will be printed))
+ * p is the hex address of a generic pointer (void *)
+ * % is the % sign
+ */
+
+void output(substdio *ss, char const *fmt, ...);
+
+#endif
diff -ruN qmail-1.03-orig/passwd.c qmail-1.03-ldap-20060201-orig/passwd.c
--- qmail-1.03-orig/passwd.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/passwd.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,360 @@
+/*
+ * Copyright (c) 2003-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#ifdef linux
+#define _XOPEN_SOURCE
+#endif
+#include <unistd.h>
+#include "base64.h"
+#include "byte.h"
+#include "case.h"
+#include "digest_md4.h"
+#include "digest_md5.h"
+#include "digest_rmd160.h"
+#include "digest_sha1.h"
+#include "qldap-debug.h"
+#include "qldap-errno.h"
+#include "str.h"
+#include "stralloc.h"
+
+#include "passwd.h"
+
+static stralloc hashed = {0};
+static stralloc salt = {0};
+static stralloc intermediate = {0};
+static stralloc cryptformat = {0};
+
+static int do_crypt(char *, char *);
+static int do_md4(char *, char *);
+static int do_md5(char *, char *);
+static int do_nsmta_md5(char *, char *);
+static int do_smd5(char *, char *);
+static int do_sha1(char *, char *);
+static int do_ssha1(char *, char *);
+static int do_rmd160(char *, char *);
+
+static struct func {
+	const char	*scheme;
+	unsigned int	slen;
+	int		(*func)(char *, char *);
+} algo[] = {
+	{ "{crypt}",	7, do_crypt },
+	{ "{md4}",	5, do_md4 },
+	{ "{md5}",	5, do_md5 },
+	{ "{ns-mta-md5}", 12, do_nsmta_md5 },
+	{ "{smd5}",	6, do_smd5 },
+	{ "{sha}",	5, do_sha1 },
+	{ "{ssha}",	6, do_ssha1 },
+	{ "{rmd160}",	8, do_rmd160 },
+	{ 0,		0, 0 }
+};
+
+/* return zero on success else the error number */
+int
+cmp_passwd(char *clear, char *encrypted)
+{
+	int	i, r;
+
+	for (i = 0; algo[i].scheme != 0; i++) {
+		if (case_diffb(encrypted, algo[i].slen, algo[i].scheme) == 0) {
+			encrypted += algo[i].slen;
+			r = algo[i].func(clear, encrypted);
+			if (r != OK) return r;
+			logit(256, "cpm_passwd: comparing hashed %s"
+			    "passwd (%S == %s)\n", 
+			    algo[i].scheme, hashed, encrypted);
+			if (str_diffn(hashed.s, encrypted, hashed.len) == 0 &&
+			    encrypted[hashed.len] == 0)
+				return OK;
+			/* hashed passwds are equal */
+			return BADPASS;
+		}
+	}
+	logit(256, "cpm_passwd: comparing crypt(3) passwd (%s == %s)\n", 
+	    crypt(clear,encrypted), encrypted);
+	if (str_diff(encrypted, crypt(clear,encrypted)) == 0)
+		return OK;
+#ifdef CLEARTEXTPASSWD
+#warning ___CLEARTEXT_PASSWORD_SUPPORT_IS_ON___
+	/* CLEARTEXTPASSWD ARE NOT GOOD */
+	/* so they are disabled by default */
+	if (str_diff(encrypted, clear) == 0)
+		return OK;
+#endif
+	return BADPASS;
+}
+
+int
+make_passwd(const char *want, char *clear, stralloc *result)
+{
+	int	i, r;
+
+	for (i = 0; algo[i].scheme != 0; i++) {
+		if (case_diffb(want, algo[i].slen, algo[i].scheme) == 0) {
+			r = algo[i].func(clear, (char *) 0);
+			if (r != OK) return r;
+			if (!stralloc_copy(result, &hashed)) return ERRNO;
+			return OK;
+		}
+	}
+	return NOSUCH;
+}
+
+int
+feed_salt(char *b, int l)
+{
+	if (!stralloc_copyb(&salt, b, l)) return ERRNO;
+	return OK;
+}
+
+void
+feed_crypt(const char *format)
+{
+	unsigned int len, slen;
+	
+	len = str_chr(format, 'X');
+	if (format[len] != 'X') goto fail;
+	if (!stralloc_copyb(&cryptformat, format, len)) goto fail;
+	for (slen = len; format[slen] == 'X'; slen++) ;
+	slen -= len;
+	if (slen * 3 > salt.len * 4) goto fail; /* slen is in base64 but salt
+						   is not. The conversion isn't
+						   100% correct but close
+						   enough. */
+	if (b64_ntops(salt.s, slen, &intermediate) == -1) goto fail;
+	if (!stralloc_catb(&cryptformat, intermediate.s, slen)) goto fail;
+	if (!stralloc_0(&cryptformat)) goto fail;
+	return;
+	
+fail:
+       	/* crypt will fail later */
+	if (!stralloc_copys(&cryptformat, "")) return;
+	if (!stralloc_copys(&intermediate, "")) return;
+}
+
+static int
+do_crypt(char *clear, char *encrypted)
+{
+	if (encrypted) {
+		if (!stralloc_copys(&hashed, crypt(clear, encrypted)))
+			return ERRNO;
+	} else {
+		/* salt and prefix */
+		if (cryptformat.s == 0 || cryptformat.len == 0)
+			return ILLVAL;
+		if (!stralloc_copys(&hashed, crypt(clear, cryptformat.s)))
+			return ERRNO;
+	}
+	return OK;
+}
+
+static int
+do_md4(char *clear, char *encrypted)
+{
+	MD4_CTX ctx;
+	unsigned char buffer[MD4_LEN];
+
+	/* not slated */
+	MD4Init(&ctx);
+	MD4Update(&ctx, clear, str_len(clear));
+	MD4Final(buffer,&ctx);
+	if (b64_ntops(buffer, sizeof(buffer), &hashed) == -1) return ERRNO;
+
+	return OK;
+}
+
+static int
+do_md5(char *clear, char *encrypted)
+{
+	MD5_CTX ctx;
+	unsigned char buffer[MD5_LEN];
+
+	MD5Init(&ctx);
+	MD5Update(&ctx, clear, str_len(clear));
+	MD5Final(buffer,&ctx);
+	if (b64_ntops(buffer, sizeof(buffer), &hashed) == -1) return ERRNO;
+
+	return OK;
+}
+
+static int
+do_nsmta_md5(char *clear, char *encrypted)
+{
+/*
+ * Netscape MTA MD5 as found in Netscape MailServer < 2.02 and 
+ * Software.com's Post.Office
+ */
+	MD5_CTX ctx;
+	unsigned char buffer[MD5_LEN];
+	unsigned char c;
+
+	/* NS-MTA-MD5 */
+	if (encrypted) {
+		if (str_len(encrypted) != 64)
+			return BADVAL;
+	
+		MD5Init(&ctx);
+		MD5Update(&ctx, &encrypted[32], 32);
+		c = 89;
+		MD5Update(&ctx, &c, 1);
+		MD5Update(&ctx, clear, str_len(clear));
+		c = 247;
+		MD5Update(&ctx, &c, 1);
+		MD5Update(&ctx, &encrypted[32], 32);
+		MD5Final(buffer, &ctx);
+
+		if (hex_ntops(buffer, sizeof(buffer), &hashed) == -1)
+			return ERRNO;
+		if (!stralloc_catb(&hashed, &encrypted[32], 32)) return ERRNO;
+		
+		return OK;
+	} else {
+		if (salt.s == 0 || salt.len < 16)
+			return FAILED;
+		if (hex_ntops(salt.s, 16, &intermediate) == -1) return ERRNO;
+		if (intermediate.len != 32) return FAILED;
+		
+		MD5Init(&ctx);
+		MD5Update(&ctx, intermediate.s, 32);
+		c = 89;
+		MD5Update(&ctx, &c, 1);
+		MD5Update(&ctx, clear, str_len(clear));
+		c = 247;
+		MD5Update(&ctx, &c, 1);
+		MD5Update(&ctx, intermediate.s, 32);
+		MD5Final(buffer, &ctx);
+
+		if (hex_ntops(buffer, sizeof(buffer), &hashed) == -1)
+			return ERRNO;
+		if (!stralloc_cat(&hashed, &intermediate)) return ERRNO;
+		
+		return OK;
+	}
+}
+
+static int
+do_smd5(char *clear, char *encrypted)
+{
+	MD5_CTX ctx;
+	
+	if (encrypted) {
+		if (b64_ptons(encrypted, &salt) == -1)
+			return BADVAL;
+
+		MD5Init(&ctx);
+		MD5Update(&ctx, clear, str_len(clear));
+		MD5Update(&ctx, salt.s + MD5_LEN, salt.len - MD5_LEN);
+		MD5Final(salt.s,&ctx);
+		if (b64_ntops(salt.s, salt.len, &hashed) == -1)
+			return ERRNO;
+		return OK;
+	} else {
+		if (salt.s == 0 || salt.len < 4)
+			return FAILED;
+		if (!stralloc_ready(&intermediate, MD5_LEN)) return ERRNO;
+		intermediate.len = MD5_LEN;
+		MD5Init(&ctx);
+		MD5Update(&ctx, clear, str_len(clear));
+		MD5Update(&ctx, salt.s, salt.len);
+		MD5Final(intermediate.s,&ctx);
+		
+		if (!stralloc_cat(&intermediate, &salt)) return ERRNO;
+		if (b64_ntops(intermediate.s, intermediate.len, &hashed) == -1)
+			return ERRNO;
+		
+		return OK;
+	}
+}
+
+static int
+do_sha1(char *clear, char *encrypted)
+{
+	SHA1_CTX ctx;
+	unsigned char buffer[SHA1_LEN];
+
+	SHA1Init(&ctx);
+	SHA1Update(&ctx, clear, str_len(clear));
+	SHA1Final(buffer,&ctx);
+	if (b64_ntops(buffer, sizeof(buffer), &hashed) == -1) return ERRNO;
+
+	return OK;
+}
+
+static int
+do_ssha1(char *clear, char *encrypted)
+{
+	SHA1_CTX ctx;
+	
+	if (encrypted) {
+		if (b64_ptons(encrypted, &salt) == -1)
+			return BADVAL;
+
+		SHA1Init(&ctx);
+		SHA1Update(&ctx, clear, str_len(clear));
+		SHA1Update(&ctx, salt.s + SHA1_LEN, salt.len - SHA1_LEN);
+		SHA1Final(salt.s,&ctx);
+		if (b64_ntops(salt.s, salt.len, &hashed) == -1)
+			return ERRNO;
+		return OK;
+	} else {
+		if (salt.s == 0 || salt.len < 4)
+			return FAILED;
+		if (!stralloc_ready(&intermediate, SHA1_LEN)) return ERRNO;
+		intermediate.len = SHA1_LEN;
+		SHA1Init(&ctx);
+		SHA1Update(&ctx, clear, str_len(clear));
+		SHA1Update(&ctx, salt.s, salt.len);
+		SHA1Final(intermediate.s,&ctx);
+		
+		if (!stralloc_cat(&intermediate, &salt)) return ERRNO;
+		if (b64_ntops(intermediate.s, intermediate.len, &hashed) == -1)
+			return ERRNO;
+		
+		return OK;
+	}
+}
+
+static int
+do_rmd160(char *clear, char *encrypted)
+{
+	RMD160_CTX ctx;
+	unsigned char buffer[RMD160_LEN];
+
+	RMD160Init(&ctx);
+	RMD160Update(&ctx, clear, str_len(clear));
+	RMD160Final(buffer,&ctx);
+	if (b64_ntops(buffer, sizeof(buffer), &hashed) == -1) return ERRNO;
+
+	return OK;
+}
+
diff -ruN qmail-1.03-orig/passwd.h qmail-1.03-ldap-20060201-orig/passwd.h
--- qmail-1.03-orig/passwd.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/passwd.h	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,51 @@
+/*
+ * Copyright (c) 2003-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#ifndef __PASSWD_H__
+#define __PASSWD_H__
+
+#include "stralloc.h"
+
+/* returns 0 on success else a errro number is returned (see qldap-errno.h) */
+int cmp_passwd(char *, char *);
+
+/* make a password */
+int make_passwd(const char *, char *, stralloc *);
+
+/* feed salt pool for passwd generation */
+int feed_salt(char *, int);
+
+/* feed crypt(3) format to the passwd function */
+void feed_crypt(const char *);
+
+#endif
diff -ruN qmail-1.03-orig/pbsadd.c qmail-1.03-ldap-20060201-orig/pbsadd.c
--- qmail-1.03-orig/pbsadd.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/pbsadd.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,362 @@
+/*
+ * Copyright (c) 2002-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#include <sys/types.h>
+#include <sys/socket.h>
+#include <netinet/in.h>
+#include <unistd.h>
+#include "alloc.h"
+#include "auto_qmail.h"
+#include "byte.h"
+#include "control.h"
+#include "env.h"
+#include "error.h"
+#include "exit.h"
+#include "fmt.h"
+#include "ip.h"
+#include "open.h"
+#include "readwrite.h"
+#include "str.h"
+#include "stralloc.h"
+#include "substdio.h"
+
+static void die(void);
+static void logit(const char* );
+static void logits(const char *);
+static void die_badenv(void);
+static void die_control(void);
+static void die_dir(void);
+static void die_exec(void);
+static void die_secret(void);
+static void log_socket(void);
+static void die_dirback(void);
+static void die_envs(void);
+static void log_nomem(void);
+static void log_envsize(void);
+static void log_envvar(char *);
+
+void setup(void);
+static void uint16_pack_big(char [], unsigned int);
+int sendrequest(int, char *, unsigned int, struct ip_address *);
+unsigned int addenv(char *, unsigned int);
+
+char sserrbuf[128];
+substdio sserr = SUBSTDIO_FDBUF(subwrite,2,sserrbuf,sizeof sserrbuf);
+
+char **childargs;
+
+#define MAX_PACKET_SIZE 1024
+char packet[MAX_PACKET_SIZE];
+
+stralloc addresses = {0};
+stralloc envs = {0};
+stralloc secret = {0};
+struct ip_address *servers;
+unsigned int numservers = 0;
+unsigned int numenvs = 0;
+unsigned int serverport = 2821;
+
+void
+setup(void)
+{
+	char* s;
+	unsigned int i, len;
+	int fdsourcedir;
+
+	fdsourcedir = open_read(".");
+	if (fdsourcedir == -1)
+		die_dir();
+
+	if (chdir(auto_qmail) == -1) die_control();
+
+	if (control_readfile(&addresses,"control/pbsservers",0) != 1)
+		die_control();
+
+	if (control_readint(&serverport,"control/pbsport") == -1)
+		die_control();
+	if (serverport > 65000)
+		die_control();
+	if (control_rldef(&secret,"control/pbssecret",0,"") != 1)
+		die_control();
+	if (secret.len > 255)
+		die_secret();
+	if (control_readfile(&envs,"control/pbsenv",0) == -1)
+		die_control();
+
+	if (fchdir(fdsourcedir) == -1)
+		die_dirback();
+	close(fdsourcedir);
+
+	for (i = 0; i < addresses.len; i++)
+		if(addresses.s[i] == '\0') numservers++;
+	if (numservers == 0) die_control();
+
+	for (i = 0; i < envs.len; i++)
+		if(envs.s[i] == '\0') numenvs++;
+	if (numenvs > 255) die_envs();
+
+	servers = (struct ip_address*)
+	    alloc(numservers * sizeof(struct ip_address));
+	if (!servers) log_nomem();
+
+	s = addresses.s;
+	for (i = 0; i < numservers; i++) {
+		len = ip_scan(s, &servers[i]);
+		if (len == 0 || len > 15) die_control();
+		while (*s++);
+	}
+
+}
+
+
+static void
+uint16_pack_big(char s[2], unsigned int u)
+{
+	s[1] = u & 255;
+	s[0] = (u >> 8) & 255;
+}
+
+int
+sendrequest(int fd, char *buf, unsigned int len, struct ip_address *ip)
+{
+	struct sockaddr_in s;
+
+	byte_zero(&s,sizeof(s));
+	byte_copy(&s.sin_addr,4,ip);
+	uint16_pack_big((char *)&s.sin_port, serverport);
+	s.sin_family = AF_INET;
+
+	return sendto(fd, buf, len, 0, (struct sockaddr*)&s, sizeof(s));
+}
+
+
+unsigned int
+addenv(char *buf, unsigned int len)
+{
+	unsigned int i;
+	unsigned int vlen;	/* length of the envvar  */
+	unsigned int elen;	/* length of the envname */
+	unsigned int telen;	/* length of the envline envname=rewritename */
+	unsigned int olen;	/* old length of the packet buffer */
+	char *e;
+	char *v;
+
+	olen = len;
+	buf += len;
+	*buf++ = numenvs; len++;
+
+	e = envs.s;
+	for (i=0; i < numenvs; i++) {
+		telen = str_len(e);
+		/* we are not interested in the rewrite name */
+		elen = str_chr(e, '=');
+		e[elen] = '\0';
+
+		/* get the requested envvar */
+		v = env_get(e);
+		vlen = v != (char *)0?str_len(v):0;
+
+		/* write the result */
+		if (elen + vlen + 1 > 255) {
+			/* Check that length indicator does not overflow */
+			log_envvar(e);
+			return olen;
+		}
+		if (len + elen + vlen + 2 > MAX_PACKET_SIZE) {
+			/*
+			 * Packet may not overflow.
+			 * The environment is written like this:
+			 *   [length]envname"="envvar
+			 */
+			log_envsize();
+			return olen;
+		}
+		*buf++ = elen + vlen + 1; len++; /* length */
+		byte_copy(buf, elen, e); buf+=elen, len+=elen; /* envname */
+		*buf++ = '='; len++; /* "=" */
+		if (vlen != 0) {
+			byte_copy(buf, vlen, v);
+			buf+=vlen;
+			len+=vlen;
+		}
+		if (len > MAX_PACKET_SIZE) {
+			/* call me paranoid ... */
+			log_envsize();
+			return olen;
+		}
+		e += telen + 1;
+	}
+	return len;
+}
+
+int
+main(int argc, char** argv)
+{
+	struct ip_address ip;
+	char *ipstr;
+	char *s;
+	int sfd;
+	unsigned int i, len;
+
+	childargs = argv + 1;
+
+	if (env_get("NOPBS")) goto done;
+
+	setup();
+
+	ipstr = env_get("TCPREMOTEIP");
+	if (!ipstr) die_badenv();
+	len = ip_scan(ipstr, &ip);
+	if (len == 0 || len > 15) die_badenv();
+
+	sfd = socket(AF_INET,SOCK_DGRAM,0);
+	if (sfd == -1) {
+		log_socket();
+		goto done;
+	}
+
+	/* create request */
+	s = packet; len = 0;
+	*s++ = 'A'; len++; /* ADD */
+	*s++ = 4; len++;   /* Size of address in bytes (4 IPv4|16 IPv6) */
+	byte_copy(s, 4, &ip); s+=4; len+=4;
+	*s++ = secret.len; len++;   /* secret length */
+	byte_copy(s, secret.len, secret.s); s+=secret.len; len+=secret.len;
+	len = addenv(packet, len);
+
+	/* send update notification to all servers */
+	for (i = 0; i < numservers; i++) {
+		sendrequest(sfd, packet, len, &servers[i]);
+	}
+	close(sfd); /* try to close socket */
+done:
+	if (!*childargs) _exit(0);
+	else execvp(*childargs,childargs);
+	/* should never reach this point */
+	die_exec();
+	/* NOTREACHED */
+	return 1;
+}
+
+static void
+die(void)
+{
+	_exit(1);
+}
+
+static void
+logit(const char* s)
+{
+	substdio_puts(&sserr,s);
+	substdio_puts(&sserr,"\n");
+	substdio_flush(&sserr);  
+}
+
+static void
+logits(const char *s)
+{
+	substdio_puts(&sserr,s);
+}
+
+static void
+die_badenv(void)
+{
+	logit("pbsadd unable to read $TCPREMOTEIP"); die();
+}
+
+static void
+die_control(void)
+{
+	logit("pbsadd unable to read controls"); die();
+}
+
+static void
+die_dir(void)
+{
+	logit("pbsadd unable to open current directory"); die();
+}
+
+static void
+die_exec(void)
+{
+	logit("pbsadd unable to start pop3 daemon"); die();
+}
+
+static void
+die_secret(void)
+{
+	logit("pbsadd control/pbssecret is to long"); die();
+}
+
+static void
+log_socket(void)
+{
+	logit("pbsadd socket syscall failed");
+}
+
+static void
+die_dirback(void)
+{
+	logit("pbsadd unable to switch back to source directory");
+	die();
+}
+
+static void
+die_envs(void)
+{
+	logit("pbsadd control/pbsenvs has to many entries");
+	die();
+}
+
+static void
+log_nomem(void)
+{
+	logit("pbsadd out of memory"); 
+	if (*childargs) _exit(111);
+	else execvp(*childargs,childargs);
+	/* should never reach this point */
+	die_exec();
+}
+
+static void
+log_envsize(void)
+{
+	logit("pbsadd to many environment entries (pkg to small)");
+}
+
+static void
+log_envvar(char *s)
+{
+	logits("pbsadd environment "); logits(s); logit(" is to big"); 
+}
+
